function BtBookmarks2() {
  const ICON_EMPTY = "chrome://bookmarks/skin/empty.png";

  const TYPE_BOOKMARK  = "http://home.netscape.com/NC-rdf#Bookmark",
        TYPE_SEPARATOR = "http://home.netscape.com/NC-rdf#BookmarkSeparator",
        TYPE_FOLDER    = "http://home.netscape.com/NC-rdf#Folder";

  var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                   .getService(Components.interfaces.nsIRDFService);
  var dataSource = rdfService.GetDataSourceBlocking("rdf:bookmarks");

  var property = {
    url:  rdfService.GetResource("http://home.netscape.com/NC-rdf#URL"),
    name: rdfService.GetResource("http://home.netscape.com/NC-rdf#Name"),
    icon: rdfService.GetResource("http://home.netscape.com/NC-rdf#Icon"),
    type: rdfService.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type")
  }

  function getValue(resource, arc) {
    var target = dataSource.GetTarget(resource, arc, true);
    if (target && 
        target instanceof Components.interfaces.nsIRDFLiteral ||
        target instanceof Components.interfaces.nsIRDFResource) return target.Value;
  }

  function getResource(id) {
    return rdfService.GetResource(id || "NC:BookmarksRoot");
  }

  this.getBookmarks = function(folderId) {
    var container = Components.classes["@mozilla.org/rdf/container;1"]
                    .createInstance(Components.interfaces.nsIRDFContainer);
    container.Init(dataSource, getResource(folderId));
    var children = container.GetElements();

    var bookmarks = [];

    while(children.hasMoreElements()) {
      var resource = children.getNext();
      resource.QueryInterface(Components.interfaces.nsIRDFResource);
      var type = getValue(resource, property.type);

      var bookmark = {
        id:          resource.Value,
        uri:         getValue(resource, property.url),
        title:       getValue(resource, property.name),
        icon:        getValue(resource, property.icon) || ICON_EMPTY,
        isFolder:    type == TYPE_FOLDER,
        isSeparator: type == TYPE_SEPARATOR
      }
      bookmarks.push(bookmark);
    }
    return bookmarks;
  }

  this.getTitle = function(id) {
    var resource = getResource(id);
    return getValue(resource, property.name);
  }
}
