function BtBookmarks3() {
  var self = this;

  this.getBookmarks = function(folderId) {
    var historyService = Components.classes["@mozilla.org/browser/nav-history-service;1"]
                         .getService(Components.interfaces.nsINavHistoryService);
    var options = historyService.getNewQueryOptions();
    var query = historyService.getNewQuery();
    query.setFolders([ folderId || getRootFolder() ], 1);
    var result = historyService.executeQuery(query, options);

    var bookmarks = [];
    if (!folderId) addToolbarFolder(bookmarks);

    result.root.containerOpen = true;
    for(var i = 0; i < result.root.childCount; i++) {
      var item = result.root.getChild(i);
      var bookmark = {
        id:          item.itemId,
        uri:         item.uri,
        title:       item.title,
        icon:        getFaviconURL(item.uri),
        isFolder:    item.type == item.RESULT_TYPE_FOLDER,
        isSeparator: item.type == item.RESULT_TYPE_SEPARATOR
      }
      bookmarks.push(bookmark);
    }
    result.root.containerOpen = false;
    return bookmarks;
  }

  function getRootFolder() {
    var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                           .getService(Components.interfaces.nsINavBookmarksService);
    return bookmarksService.bookmarksMenuFolder;
  }

  function addToolbarFolder(bookmarks) {
    var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                           .getService(Components.interfaces.nsINavBookmarksService);
    var id = bookmarksService.toolbarFolder;
    bookmarks.push({
      id: id,
      title: self.getTitle(id),
      isFolder: true
    });
    bookmarks.push({
      isSeparator: true
    });
  }

  this.getTitle = function(id) {
    var bookmarksService = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
                           .getService(Components.interfaces.nsINavBookmarksService);
    return bookmarksService.getItemTitle(id);
  }

  function getFaviconURL(url) {
    var faviconService = Components.classes["@mozilla.org/browser/favicon-service;1"]
                         .getService(Components.interfaces.nsIFaviconService);
    var nsiUrl = BtURL.getNsiURL(url);
    var faviconUrl = faviconService.getFaviconImageForPage(nsiUrl);
    return faviconUrl.spec;
  }
}
