var BtTabLoader = {
  TIMEOUT: 100,
  isNewTab: false,

  start: function() {
    addEventListener("load", function() {
      BtTabLoader.loadInExistingTabs();

      gBrowser.addEventListener("load", BtTabLoader.onPageLoad, true);
      gBrowser.addEventListener("NewTab", BtTabLoader.onNewTab, false);

      var tabMenu = document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");
      var newTabContextItem = tabMenu.firstChild;
      newTabContextItem.addEventListener("command", BtTabLoader.onNewTab, false);

      var newTabCommand = $("cmd_newNavigatorTab");
      newTabCommand.addEventListener("command", BtTabLoader.onNewTab, false);
    },
    false);
  },

  isBlank: function(doc) {
    return doc && doc.location == "about:blank";
  },

  getURL: function() {
    return BtPrefs.getString("startPage");
  },

  loadIn: function(doc) {
    var url = BtTabLoader.getURL();
    if (url && url != "about:blank") {
      doc.location = url;
      BtTabLoader.clearUrlBar();
    }
  },

  loadInExistingTabs: function() {
    var tabs = gBrowser.tabContainer.childNodes;
    for(var i = 0; i < tabs.length; i++) {
      var tab = tabs[i];
      if (!tab.hasAttribute("busy")) {
        var doc = tab.linkedBrowser.contentDocument;
        if (BtTabLoader.isBlank(doc)) BtTabLoader.loadIn(doc);
      }
    }
  },

  onNewTab: function() {
    BtTabLoader.isNewTab = true;
  },

  onPageLoad: function(e) {
    var doc = e.originalTarget;
    if (doc.location == BtTabLoader.getURL()) {
      BtTabLoader.addToHistory(doc.location, doc.title);
    }
    var singleTab = gBrowser.tabContainer.childNodes.length == 1;
    if ((BtTabLoader.isNewTab || singleTab) && BtTabLoader.isBlank(doc)) {
      BtTabLoader.isNewTab = false;
      BtTabLoader.loadIn(doc);
    }
  },

  addToHistory: function(url, title) {
    var entry = Components.classes["@mozilla.org/browser/session-history-entry;1"]
                .createInstance(Components.interfaces.nsISHEntry);
    entry.setURI(BtURL.getNsiURL(url));
    entry.setTitle(title);

    var sessionHistory = gBrowser.sessionHistory;
    if (sessionHistory) {
      sessionHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
      if (!sessionHistory.count) {
        sessionHistory.addEntry(entry, true);
      }
    }
  },

  clearUrlBar: function() {
    var urlbar = $("urlbar");
    var input = document.getAnonymousElementByAttribute(urlbar, "anonid", "input");
    input.style.visibility = "hidden";

    setTimeout(function() {
      $("urlbar").value = "";
      input.style.visibility = "visible";
      $("urlbar").select();
    }, BtTabLoader.TIMEOUT);
  }
}
